<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Intern Test</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron p-5 mt-4">
        <div class="text-center mb-5">
            <h2>Infor Form</h2>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label" for="inp-fname">First Name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-4">
                <input type="text" id="inp-fname" placeholder="Your name.." class="form-control">
            </div>
            <label class="col-sm-2 col-form-label" for="inp-lname">Last Name<span class="text-danger">(*)</span></label>
            <div class="col-sm-4">
                <input type="text" id="inp-lname" placeholder="Your last name.." class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label" for="inp-phone">Phone Number<span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-4">
                <input type="text" id="inp-phone" placeholder="Your phone number.." class="form-control">
            </div>
            <label class="col-sm-2 col-form-label" for="inp-email">Email<span class="text-danger">(*)</span></label>
            <div class="col-sm-4">
                <input type="text" id="inp-email" placeholder="Your email.." class="form-control">
            </div>
        </div>

        <div class="row form-group">
            <label class="col-sm-2 col-form-label">Country</label>
            <div class="col-sm-4">
                <select id="country-select" name="country" class="form-control">
                </select>
            </div>
            <label class="col-sm-2 col-form-label">District</label>
            <div class="col-sm-4">
                <select id="district-select" name="country" disabled class="form-control">
                </select>
            </div>
        </div>
        <div class="row form-group text-right">
            <div class="col-sm-12">
                <button class="btn btn-info px-4" id="btn-send">Submit</button>
            </div>
        </div>
    </div>

    <!-- vùng hiển thị thông tin submit mặc định bị ẩn -->
    <div id="div-container-submit" class="container bg-info" style="display: none;">
        <div id="div-submit-infor" class="text-white p-3">...</div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    //Country infor
    var gJsonCountryData = `[
                          {"countryId": "0","countryName": "None", "district": []}, 
                          {"countryId": "1","countryName": "Hà Nội", "district": [{"disrictId":"0", "districtName":"Tây Hồ"},{"disrictId":"1","districtName":"Hoàn Kiếm"},{"disrictId":"2","districtName":"Ba Đình"}]},
                          {"countryId": "2","countryName": "Bắc Ninh", "district": [{"disrictId":"0","districtName":"Yên Phong"},{"disrictId":"1","districtName":"Tiên Du"},{"disrictId":"2","districtName":"Lương Tài"}]},
                          {"countryId": "3","countryName": "Hải Dương", "district": [{"disrictId":"0","districtName":"Thanh Miện"},{"disrictId":"1","districtName":"Thanh Hà"},{"disrictId":"2","districtName":"Ninh Giang"}]}
                        ]`;

    var gObjCountryData = JSON.parse(gJsonCountryData);
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
    });

    //Gán sự kiện cho country select
    $("#country-select").on("change", function () {
        onCountrySelectChange();
    });

    //gán sự kiện cho nút Submit
    $("#btn-send").on("click", function () {
        onBtnSubmitClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //load dữ liệu lên select country
        loadDataCountrySelect()
    }

    //Hàm xử lý gán sự kiện cho select
    function onCountrySelectChange() {
        var vCountryId = $("#country-select").val();
        console.log(vCountryId);

        var vCountryTypeSelect = $("#district-select");
        var vDistrictName = getDistrictNameByCountryId(vCountryId);
        vCountryTypeSelect.html("");
        if (vDistrictName.length == 0) {
            vCountryTypeSelect.prop("disabled", "disabled");
        }
        else {
            vCountryTypeSelect.prop("disabled", false);

            for (var bI = 0; bI < vDistrictName.length; bI++) {
                $("<option>", {
                    html: vDistrictName[bI].districtName,
                    value: vDistrictName[bI].disrictId
                }).appendTo(vCountryTypeSelect);
            }
        }
    }

    //Hàm xử lý nút submit
    function onBtnSubmitClick() {
        //Khai báo Obj
        var vUserObj = {
            firstname: "",
            lastname: "",
            phonenumber: "",
            email: "",
            country: 0,
            district: "",
        };
        //Thu thập data
        thuThapData(vUserObj);
        //Validate
        var vDuLieuHopLe = kiemTraData(vUserObj);
        if (vDuLieuHopLe) {
            //Hiển thị thông tin submit
            vHienThiData(vUserObj);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm load dữ liệu lên select country
    function loadDataCountrySelect() {
        var vCountrySelect = $("#country-select");
        for (var bI = 0; bI < gObjCountryData.length; bI++) {
            var bCountryOption = $("<option>", { html: gObjCountryData[bI].countryName, value: gObjCountryData[bI].countryId }).appendTo(vCountrySelect);
        }
    }

    //Hàm get district name
    function getDistrictNameByCountryId(paramcountryId) {
        var vDistrictFound = false;
        var vdistrictResult = null;
        var vIterator = 0;
        while (!vDistrictFound && vIterator < gObjCountryData.length) {
            if (gObjCountryData[vIterator].countryId === paramcountryId) {
                vDistrictFound = true;
                vdistrictResult = gObjCountryData[vIterator].district;
            }
            else {
                vIterator++;
            }
        }
        return vdistrictResult;
    }

    //Hàm thu thập data
    function thuThapData(paramObj) {
        paramObj.firstname = $("#inp-fname").val().trim();
        paramObj.lastname = $("#inp-lname").val().trim();
        paramObj.phonenumber = $("#inp-phone").val().trim();
        paramObj.email = $("#inp-email").val().trim();
        paramObj.country = $("#country-select").val();
        paramObj.district = $("#district-select").val();
    }
    //Hàm validate
    function kiemTraData(paramObj) {
        if (paramObj.firstname == "") {
            alert("Vui lòng nhập firstname");
            return false;
        }
        if (paramObj.lastname == "") {
            alert("Vui lòng nhập lastname");
            return false;
        }
        if (isNaN(paramObj.phonenumber)) {
            alert("Số điện thoại nhập vào phải là số");
            return false;
        }
        if (paramObj.phonenumber.charAt(0) != "+" && paramObj.phonenumber.charAt(0) != "0") {
            alert("Số điện thoại phải có số 0 hoặc dấu + ở đầu");
            return false;
        }
        if (paramObj.phonenumber.length < 10 || paramObj.phonenumber.length > 12) {
            alert("Số điện thoại phải từ 10 đến 12 ký tự");
            return false;
        }
        if (kiemTraEmail(paramObj.email) == false) {
            alert(paramObj.email + " không phải là email");
            return false;
        }
        return true;
    }
    //Hàm kiểm tra email
    function kiemTraEmail(paramEmail) {
        var vRegex = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
        var vResult = false;
        if (paramEmail.match(vRegex)) {
            vResult = true;
        }
        return vResult;
    }

    //Hàm hiển thị thông tin
    function vHienThiData(paramObj) {
        var vDivContain = document.getElementById("div-container-submit");
        var vDivInfor = document.getElementById("div-submit-infor");

        var vCountrySelect = document.getElementById("country-select");
        var vTextCountry = vCountrySelect.options[vCountrySelect.selectedIndex].text;
        var vDistrictSelect = document.getElementById("district-select");
        var vTextDistrict = vDistrictSelect.options[vDistrictSelect.selectedIndex].text;

        vDivContain.style.display = "block";
        vDivInfor.innerHTML = "First name: " + paramObj.firstname + "<br>";
        vDivInfor.innerHTML += "Last name: " + paramObj.lastname + "<br>";
        vDivInfor.innerHTML += "Phone nunber: " + paramObj.phonenumber + "<br>";
        vDivInfor.innerHTML += "Email: " + paramObj.email + "<br>";
        vDivInfor.innerHTML += "Country: " + vTextCountry + "<br>";
        vDivInfor.innerHTML += "District: " + vTextDistrict;
    }
</script>

</html>